# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'StreamKinesisConfigurationArgs',
    'StreamKinesisConfigurationArgsDict',
]

MYPY = False

if not MYPY:
    class StreamKinesisConfigurationArgsDict(TypedDict):
        stream_arn: pulumi.Input[builtins.str]
        """
        The Amazon Resource Name (ARN) of the Kinesis Data Streams resource.
        """
        aggregation_enabled: NotRequired[pulumi.Input[builtins.bool]]
        """
        Enables QLDB to publish multiple data records in a single Kinesis Data Streams record, increasing the number of records sent per API call. Default: `true`.
        """
elif False:
    StreamKinesisConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StreamKinesisConfigurationArgs:
    def __init__(__self__, *,
                 stream_arn: pulumi.Input[builtins.str],
                 aggregation_enabled: Optional[pulumi.Input[builtins.bool]] = None):
        """
        :param pulumi.Input[builtins.str] stream_arn: The Amazon Resource Name (ARN) of the Kinesis Data Streams resource.
        :param pulumi.Input[builtins.bool] aggregation_enabled: Enables QLDB to publish multiple data records in a single Kinesis Data Streams record, increasing the number of records sent per API call. Default: `true`.
        """
        pulumi.set(__self__, "stream_arn", stream_arn)
        if aggregation_enabled is not None:
            pulumi.set(__self__, "aggregation_enabled", aggregation_enabled)

    @property
    @pulumi.getter(name="streamArn")
    def stream_arn(self) -> pulumi.Input[builtins.str]:
        """
        The Amazon Resource Name (ARN) of the Kinesis Data Streams resource.
        """
        return pulumi.get(self, "stream_arn")

    @stream_arn.setter
    def stream_arn(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "stream_arn", value)

    @property
    @pulumi.getter(name="aggregationEnabled")
    def aggregation_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enables QLDB to publish multiple data records in a single Kinesis Data Streams record, increasing the number of records sent per API call. Default: `true`.
        """
        return pulumi.get(self, "aggregation_enabled")

    @aggregation_enabled.setter
    def aggregation_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "aggregation_enabled", value)


